# prntchecks.awk - print formatted checks
# input: - print numbr \t amount \t payee
#output: eight lines of text for preprinted check forms

BEGIN { 
     FS = "\t"
     dashes = sp45 = sprintf("%45s", " ")
     gsub(/ /,"-", dashes)
     "date" | getline date
     split(date, d, " ")
     date = d[2] " " d[3] " ,  " d[6]
     initnum()
     }
NF != 3 || $2 >= 100000 {     # illegal data
     printf("\nline %d illegal: \n%s\n\nVOID\nVOID\n\n\n",nr, $0)
     next
}
{ 
  printf("\n")             # nothing in line 1
  printf("%s%s", sp45, $1)    # number idented 45 spaces
  printf("%s%s\n", sp45, date)  # date idented 45 spaces
  amt = sprintf("%.2f", $2)
  printf("Pay to %45.45s $%s\n", $3 dashes, amt) # line 4
  printf("the sum of %s\n", numtowords(amt))  #line 5
  printf("\n\n\n")
}

function numtowords(n) # n has two decimal places
{
  cents = substr(n, length(n)-1, 2)
  dols = substr(n, 1, length(n)-3)
  if ( dols == 0)
   return " zero dollars and " cents " cents exactly"
  return intowords(dols) " dollars and " cents " cents exactly "
  
} # numtowords   

function intowords(n) 
  {
   n = int(n)
   if ( n >= 1000)
      return intowords(n/1000) " thousand " intowords(n%1000)
   if ( n >= 100)
      return intowords(n/100) " hundred " intowords(n%100)
   if ( n >= 20)
      return tens[int(n/10)] "  " intowords(n%10)
   return nums[n]
  } # intowords 

function initnum()
{
  split("one two three four five six seven eight nine " \
        " ten eleven twelve thirteen thirteen fourteen fifteen " \
        " sixteen seventeen eighteen nineteen ", nums, " " )
   split("ten twenty thirty fourty fifty sixty seventy eighty " \
        " ninety ", tens, " " )


} # initum
