/*
   File copy.h, an addition to copy.c to get second version
   of the programm
*/

/* Giving a result of ls processing source pattern
   extract a source name from it and resume copy */
static void ExtractNames (char *Pattern, char *Args)
{
    char    SourceName[40];
    char    ResName[40];
    int     i = 0, j = 0;

    while (Buffer[i] != 0) {
	while (Buffer[i] != '\n' && Buffer[i] != 0)
	    SourceName[j++] = Buffer[i++];
	SourceName[j] = 0;
	i++;
	j = 0;
	ComposeName (SourceName, Pattern, ResName);
	DoCopy (SourceName, ResName, Args);
    }
}

/* Appending to the summary buffer results of reading
   from pipe from command ls */
static void AppendToBuffer (char *Buf, int nread)
{
    static int AlreadyInBuf = 0;
    int     sum = AlreadyInBuf + nread;
    int     i;

    for (i = AlreadyInBuf; i < sum; i++)
	Buffer[i] = Buf[i - AlreadyInBuf];
    Buffer[i + 1] = 0;
}

/* Opening a pipe to ls command and resuming achild
   process to get names that matches the pattern */
void    ResumeLsProc (int argv, char *argc[], char *Args)
{
    int     lsOut[2];		/* Pipe handlers for standart output of ls
				   command */
    char    buf[512];
    int     nread;

    if (pipe (lsOut) == -1)	/* Opening pipe for ls input */
	perror ("Cannot open pipe for ls command");

    /* Creating the child process that resumes ls */
    switch (fork ()) {
	/* We are in child process */

    case -1:
	perror ("Error in creating child process");
    case 0:			/* Child process */
	if (close (1) == -1)
	    perror ("Cannot close stdout");
	if (dup (lsOut[1]) != 1)
	    perror ("Cannot create a pipe for ls");
	if (close (lsOut[0]) == -1 || close (lsOut[1]) == -1)
	    perror ("Cannot close opened pipes");
	execlp ("ls", "ls", "-o", "-1", argc[argv - 2], NULL);
	perror ("ls finished with error");
    }
    /* We are in parent process */
    if (close (lsOut[1]) == -1)
	perror ("Cannot close the pipe");
    while ((nread = read (lsOut[0], buf, sizeof (buf))) != 0) {
	if (nread == -1)
	    perror ("Error in reading ls information");
	AppendToBuffer (buf, nread);
    }
    if (close (lsOut[0]) == -1)
	perror ("Cannot close a pipe");
    ExtractNames (argc[argv - 1], Args);
}
