#include <stdio.h>
#include <sys/shm.h>
#include <sys/types.h>
#include <sys/ipc.h>

typedef struct value_data
{
   char value;
   int *nptr;
   //int flag;
   int pid1;
   int pid2;
}VALUE_DATA, *VALUE_DATA_PTR;

VALUE_DATA_PTR nptr;

void sys_err(char str[])
{
   perror(str);
   exit(0);
}

int create_pid_pipe(int pid1, int pid2)
{
   int key, sid;

   key = pid1 + pid2;
   sid = shmget(key, sizeof(VALUE_DATA), 0666);
   if (sid == -1)
   {
       sid = shmget(key, sizeof(VALUE_DATA), 0666|IPC_CREAT);
       nptr = (VALUE_DATA_PTR)shmat(sid,0,0);
       nptr->pid1 = pid1;
       (*nptr).pid2 = pid2;
	   /* shmdt((*nptr).nptr); */
   }
   else
   {
       nptr = (VALUE_DATA_PTR)shmat(sid,0,0);   
	   if (sid < 0)
          sys_err("shmget");
       /* shmdt(value_data.nptr); */
   }
   return (sid);
}

int write_pid_pipe(char info, int pipe_id)
{
   int flag;
   if ( pipe_id != (*nptr).pid1 )
	  return (-1);
   else
   {
     flag = -1;
     //if (flag == -1) 
     flag = msgsnd(pipe_id, &info, 1, IPC_NOWAIT);
     if (flag == 0)
      return 1;
     else
      return (-1);
   }
}

int read_pid_pipe(char *info, int pipe_id)
{
   int flag;
   if ( pipe_id != (*nptr).pid2 )
	  return (-1);
   else
   {
     flag = -1;
     //while (flag == -1)
     flag = msgrcv(pipe_id, (char*)&info, sizeof(char), 1, IPC_NOWAIT);   
     if (flag == 0)
       return 1;
     else
       return (-1);
   }
}

int free_pid_pipe(int pipe_id)
{
   struct shmid_ds buff;

   if (shmctl(pipe_id, IPC_RMID, &buff) == -1)
      return (-1);
   else
      return 1;
}

void main()
{
   int pipe_id, ppid, pid, len, status, i, id;
   char str[] = "Hello World!\n";
   char in_str[20];

   len = strlen(str);
   ppid = getpid();
   pid = fork();
   if (pid == 0) /* child process */
   {
     pipe_id = create_pid_pipe(ppid, getpid());
     for (i = 0; i <= len; i++)
       write_pid_pipe(str[i], id);
   } /* if */
   else /* parent process */
   {
     pipe_id = create_pid_pipe(ppid, pid);
     do{
       i++;
       read_pid_pipe(&in_str[i], pipe_id);
     } while(in_str[i] != '\0');
     printf("\n in_str = %s\n", in_str);
     wait(&status);
     free_pid_pipe(pipe_id);
   } /* else */
} /* main */


 
