/*  fiforecv.c */

#include <fcntl.h>
#include <stdio.h>
#include <errno.h>
#include <stdlib.h>
#include <string.h>

#define MAX_MSGSIZE 80

char *fifo = "/tmp/newfifo";

void fatal(char str[])
{
 fprintf(stderr, "%s\n", str);
 exit(0);
} /* fatal */

int main()
{
 int fd, i, nwrite;
 char msgbuf[MAX_MSGSIZE];

 /* Create fifo, unless it already exits */

 if(mkfifo(fifo, 0600) == -1)
   if (errno != EEXIST)
      fatal("mkfifo failed");

 if ( (fd = open(fifo, O_RDWR)) < 0)
   fatal("fifo open failed");
 
 if ( read(fd, msgbuf,MAX_MSGSIZE ) < 0)
   fatal("fifo write failed");

 printf("received: %s\n",  msgbuf);

 if (remove(fifo) < 0)
   perror("remove");

 return 0;

} /* main */

