/* group4.c - group demo.  */

#include <stdio.h>
#include <signal.h>
#include <stdlib.h>
#include <unistd.h>

void sys_err(char str[])
{
  perror(str);
  exit(1);
} /*  sys_err */

void main() 
{
  int grpid, new_grppid, old_grppid, i;
  
  grpid = getpgrp();

  printf("pid = %d\n", getpid());
  printf("grpid = %d\n\n", grpid);

  switch(fork())
  {
   case -1:
      sys_err("fork");
   case 0:
    for (i=1; i < 50; i++)
     {
       printf("Child 1:... \n");
       sleep(2);
     } /* for */
    exit(0); 

  } /* switch */

  switch(fork())
  {
   case -1:
      sys_err("fork");
   case 0:
    for (i=1; i < 50; i++)
     {
       printf("Child 2:... \n");
       sleep(2);
     } /* for */
    exit(0); 

  } /* switch */


  switch(fork())
  {
   case -1:
      sys_err("fork");
   case 0:
     old_grppid = getpgrp();
     if (setpgrp() == -1)
            sys_err("setpgrp");

     new_grppid = getpgrp();
  
    printf("Child 3:pid = %d\n", getpid());
    printf("old_grppid = %d, new_grppid = %d\n\n",
                               old_grppid, new_grppid);

    for (i=1; i < 10; i++)
     {
       printf("Child 3:... \n");
       sleep(2);
     } /* for */
    exit(0); 

  } /* switch */


   for (i=0; i < 5; i++)
     {
       printf("Parent Process:... \n");
       sleep(2);
     } /* for */

   kill(0, SIGTERM);


} /* main */
