/* memdemo3.c - demonstrate shared memory segments - UNIX system V */

#include <stdio.h>

#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/shm.h>


void sys_err(char s[])
{
   perror(s);
   exit(1);
}
  


void main()
{
  int id, *nptr;
  int memid;
  struct shmid_ds buff;

  if ( (memid = shmget(4040, sizeof(int), 0666|IPC_CREAT)) < 0)
         sys_err("Cannot shmget");


  if ( ( id =  fork() ) == 0 )
  {  /* select child process */
     puts("\n**************  child process ***********\n");

     if ( (nptr = (int *)shmat(memid,0,0)) == (int *) -1)
           sys_err("Cannot shmat");

     *nptr = 999;

     printf("PID is %d and ID is %d.\n", getpid(), id);
     printf("*nptr is %d and nptr is %p.\n", *nptr, nptr);
     puts("\n**************  child process ***********\n");

     sleep(6);

     puts("\n**************  child process ***********\n");

     printf("PID is %d and ID is %d.\n", getpid(), id);
     printf("*nptr is %d and nptr is %p.\n", *nptr, nptr);
     puts("\n**************  child process ***********\n");

     if (shmdt(nptr) < 0)
         sys_err("Cannot shmdt");

                           /* Release the shared segment */
     if ( shmctl(memid, IPC_RMID, &buff) < 0 )
        sys_err("Cannot shmctl");  
                                  /* Note that child terminates last */

     exit(0);
  }

/* Parent process only */

     sleep(5);

     if ( (nptr = (int *)shmat(memid,0,0)) == (int *) -1)
           sys_err("Cannot shmat");

     puts("\n**************  parent process ***********\n");
     printf("PID is %d and ID is %d.\n", getpid(), id);
     printf("*nptr is %d and nptr is %p.\n", *nptr, nptr);

     *nptr = 444;
     printf("*nptr is %d and nptr is %p.\n", *nptr, nptr);

     puts("\n**************  parent process ***********\n");

     if (shmdt(nptr) < 0)
         sys_err("Cannot shmdt");

}


