/* msgp1.c - Use System V messages */

#include <stdio.h>
#include <sys/types.h>
#include <sys/msg.h>

void sys_err(char s[])
{
   perror(s);
   exit(1);
}

long int mesgq;
int sid;
struct msqid_ds buff;

receiver()
{
 struct msgbuf msg;
 char text[30] = {'\0'};
 int i = 0;

  do { 
    int n;
    n = msgrcv(mesgq, &msg, 1, 1L , MSG_NOERROR);
    if ( n < 1 )
     sys_err("msgrcv error");

    text[i++] = msg.mtext[0];

  } while ( msg.mtext[0] != '\0');

  printf("Received:  %s \n",text);

  if ( msgctl(mesgq, IPC_RMID, &buff) < 0)
     sys_err("Cannot remove message queue");

}

sender()
{
  int i;
  struct msgbuf msg[13] = { {1,'H'},{1,'e'},{1,'l'},{1,'l'},{1,'o'},
                            {1,' '},{1,'W'},{1,'o'},{1,'r'},{1,'l'},
                            {1,'d'},{1,'\n'},{1,'\0'} };

  for (i=0; i < 13; i++) 
    if ( msgsnd(mesgq, &msg[i], 1, IPC_NOWAIT) < 0 )
        sys_err("msgsnd error");

}


void main()
{
  

  if ( (mesgq = msgget(IPC_PRIVATE, 0666)) < 0)
       sys_err("Cannot msgget");

  printf("mesgq == %ld\n", mesgq);

  if (sid = fork())
     sender();
  else
     receiver();

} /* main */

