/* msgp1a.c - Use System V messages */

#include <stdio.h>
#include <sys/ipc.h>
#include <sys/types.h>
#include <sys/msg.h>

struct msgbuf
  {
    long int mtype;             /* type of received/sent message */
    char mtext[1];              /* text of the message */
  };


void sys_err(char s[])
{
   perror(s);
   exit(1);
}

long int mesgq;
int sid;
struct msqid_ds buff;

receiver()
{
 struct msgbuf msg;
 char text[30] = {'\0'};
 int i = 0;

  do { 
    int n;
    n = msgrcv(mesgq, &msg, 1, 722L , MSG_NOERROR);
    if ( n < 1 )
     sys_err("msgrcv error");

    text[i++] = msg.mtext[0];

  } while ( msg.mtext[0] != '\0');

  printf("Received:  %s \n",text);

  if ( msgctl(mesgq, IPC_RMID, &buff) < 0)
     sys_err("Cannot remove message queue");

} /* receiver */

sender()
{
  int i;
  struct msgbuf msg[14] = { {722,'H'},{722,'e'},{722,'l'},{722,'l'},{722,'o'},
                            {722,' '},{722,'W'},{722,'o'},{722,'r'},{722,'l'},
                            {722,'d'},{722,'!'},{722,'\n'},{722,'\0'} };

  for (i=0; i < 14; i++) 
    if ( msgsnd(mesgq, &msg[i], 1, IPC_NOWAIT) < 0 )
        sys_err("msgsnd error");

} /* sender */


int main()
{
  

  if ( (mesgq = msgget(IPC_PRIVATE, 0666)) < 0)
       sys_err("Cannot msgget");

  printf("mesgq == %ld\n", mesgq);

  if (sid = fork())
     sender();
  else
     receiver();

  return 0;
} /* main */

