/* msgprog3.c - Use System V messages */

#include <stdio.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>


typedef struct mymsgbuf {
                  long int mtype;
                  char text[13];
                  } MYMSGBUF;

long int mesgq;
int sid;
struct msqid_ds buff;


void sys_err(char s[])
{
   perror(s);
   exit(1);
}
  

receiver()
{
 
  MYMSGBUF msg;
  int n;

  n = msgrcv(mesgq, (struct msgbuf *)&msg, 13, 1L , MSG_NOERROR);
  
  /* In THIS program, the message is known to be 13 bytes */
  if (n < 13)
    sys_err("msgrcv error");


  printf("Received:  %s \n",msg.text);

  if ( msgctl(mesgq, IPC_RMID, &buff) < 0)
     sys_err("Cannot remove message queue");


}  /* receiver */

sender()
{
  int i;

    MYMSGBUF msg1 = {1, "Hello World"};

    if ( msgsnd(mesgq, (struct msgbuf *)&msg1, 13, IPC_NOWAIT) < 0 )
        sys_err("msgsnd error");

} /* sender */


void main()
{
  
  if ( (mesgq = msgget(IPC_PRIVATE, 0666)) < 0)
       sys_err("Cannot msgget");
 
  printf("mesgq == %ld\n", mesgq);

  if (sid = fork())
     sender();
  else
     receiver();

} /* main */

