/* msgprog4.c - Use System V messages */

#include <stdio.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>


typedef struct mymsgbuf {
                  long int mtype;
                  char text[13];
                  } MYMSGBUF;

long int mesgq;
int sid;
struct msqid_ds buff1;


void sys_err(char s[])
{
   perror(s);
   exit(1);
}
  

receiver()
{
 
  int n;
  char *buff;

  buff = malloc(200);

  n = msgrcv(mesgq, (struct msgbuf *)buff, 14, 1L , MSG_NOERROR);
  
  /* In THIS program, the message is known to be 13 bytes */
  if (n < 13)
    sys_err("msgrcv error");


  printf("Received:  %s \n", (char *)(buff+sizeof(long int)));

  if ( msgctl(mesgq, IPC_RMID, &buff1) < 0)
     sys_err("Cannot remove message queue");


}  /* receiver */

sender()
{
  int i;
  long int mtype;
  char *buff;

  buff = malloc(sizeof(long int) + 14);
  memcpy(buff+sizeof(long int), "Hello World!", 14);


    if ( msgsnd(mesgq, (struct msgbuf *)buff, 14, IPC_NOWAIT) < 0 )
        sys_err("msgsnd error");

} /* sender */


void main()
{
  
  if ( (mesgq = msgget(IPC_PRIVATE, 0666)) < 0)
       sys_err("Cannot msgget");
 
  printf("mesgq == %ld\n", mesgq);

  if (sid = fork())
     sender();
  else
     receiver();

} /* main */

