/* pipe2.c - send information through pipe.  */

#include <stdio.h>
#include <unistd.h>

void syserr(char str[])
{
  perror(str);  
  exit(1);
} /* sys_arr */


void child(int  pfd[])
{
  char msg[80];
  
  if (close(pfd[1]) == -1)
       syserr("close");
  if (read(pfd[0], msg, 80) == -1)
         syserr("read");

  printf("Received  = %s\n", msg);
  exit(0);

} /* child */

int main()
{
  int  pfd[2];
  char fdstr[10];
  int i;
  char str[] = "Hello World!\n";

  if (pipe(pfd) == -1)
    syserr("pipe");
  printf("pfd[0] = %d, pfd[1] = %d\n", pfd[0], pfd[1]); 

  switch(fork())
  {
   case -1:
     syserr("fork");
   case 0:
     child(pfd);
   default:
      break; 
  } /* switch */

/* parent only */
  if (close(pfd[0]) == -1)
    syserr("close");
 
  sleep(3);
  if (write(pfd[1], str, strlen(str)+1) == -1)
        syserr("write");
   

return 0;

}/* main */
