/* semaph2.c -  prod2, cons2 */

#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/sem.h>


int	*n;		/* external variables are shared by all processes */

int screate(key, q)
int key;
int q;
{
  int result;
  
  result = semget( (key_t) key, q, 0666 | IPC_CREAT ); 

  return result;

}

int waitsem(sid, indx)
int sid;
int indx;
{
  struct sembuf sb;

  sb.sem_num  = indx;
  sb.sem_op = -1;
  sb.sem_flg = 0;

  semop(sid, &sb, 1);
}

int sigsem(sid,indx)
int sid;
int indx;
{
  struct sembuf sb;

  sb.sem_num  = indx;
  sb.sem_op = 1;
  sb.sem_flg = 0;

  semop(sid, &sb, 1);
}



/*------------------------------------------------------------------------
 *  main  --  producer and consumer processes synchronized with semaphores
 *------------------------------------------------------------------------
 */
void  main()
{
	int	prod2(), cons2();
	int	semid, shmid;

	semid = screate(0,2);
        shmid = shmget(0, sizeof(int), 0666|IPC_CREAT);  
        n = (int*)shmat(shmid,0,0);
        *n = 0;

        sigsem(semid, 0);

        if ( fork() )
          /* Parent process    */
           cons2(semid, 0, 1);
        else /* Child process */
         prod2(semid, 1, 0);

        shmdt(n);

}

/*------------------------------------------------------------------------
 *  prod2  --  increment n 20 times, waiting for it to be consumed
 *------------------------------------------------------------------------
 */

int prod2(semid, indx1, indx2)
int semid, indx1, indx2;
{
	int	i;


	for (i=1; i<=20; i++) {
		waitsem(semid, indx1);
		(*n)++;
		sigsem(semid, indx2);
	}
}

/*------------------------------------------------------------------------
 *  cons2  --  print n 20 times, waiting for it to be produced
 *------------------------------------------------------------------------
 */

int cons2(semid, indx1, indx2)
int semid, indx1, indx2;
{
	int	i;



	for (i=1; i<=20; i++) {
		waitsem(semid, indx1);
		printf("n is %d\n", *n);
		sigsem(semid, indx2);
	}
}
