/* semaph5.c -  prod2, cons2 */

#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/sem.h>
#include <sys/shm.h>



int	*n;		/* Shared memory variable */


void sys_err(char s[])
{
   perror(s);
   exit(1);
}
  


int screate(key, q)
int key;
int q;
{
  int result;
  
  if ( (result = semget( (key_t) key, q, 0666 | IPC_CREAT )) < 0 )
        sys_err("Cannot semget"); 

  return result;

}

int waitsem(sid, indx)
int sid;
int indx;
{
  struct sembuf sb;

  sb.sem_num  = indx;
  sb.sem_op = -1;
  sb.sem_flg = 0;

  if ( semop(sid, &sb, 1) < 0 )
          sys_err("semop waitsem error");

}

int sigsem(sid,indx)
int sid;
int indx;
{
  struct sembuf sb;

  sb.sem_num  = indx;
  sb.sem_op = 1;
  sb.sem_flg = 0;

  if ( semop(sid, &sb, 1) < 0)
        sys_err("semop sigsem error");
}



/*------------------------------------------------------------------------
 *  main  --  producer and consumer processes synchronized with semaphores
 *------------------------------------------------------------------------
 */
void  main()
{
	int	prod2(), cons2();
	int	semid, shmid;
        int     id;
 
        struct shmid_ds buff;
        union semun 
           {
                  int val;
                  struct semid_ds *buf;
                  u_short *array;
           }  buff1;
 
	semid = screate(0,2);

        if ( (shmid = shmget(0, sizeof(int), 0666|IPC_CREAT) ) < 0)
               sys_err("Cannot shmget shmid");
         
        if ( (n = (int*)shmat(shmid,0,0)) == (int *) -1)
                 sys_err("Cannot shmat n");
 
        *n = 0; /* Initialize *n */

        sigsem(semid, 0);

        if ( (id = fork()) )
          /* Parent process    */
           cons2(semid, 0, 1);
        else /* Child process */
         prod2(semid, 1, 0);

        if (shmdt((char *)n) < 0)
           sys_err("Cannot shmdt");

        if (id) /* Consumer is last to use the shared segment/semaphore */
         {
           int status;
    
           wait(&status); /* consumer is parent */
           if ( semctl(semid, 2, IPC_RMID, &buff) < 0 )
                 sys_err("Semaphore remove (semctl) error");
           if ( shmctl(shmid, IPC_RMID, &buff1) < 0 )
                 sys_err("Segment remove (shmctl) error");
         }
 

}

/*------------------------------------------------------------------------
 *  prod2  --  increment n 20 times, waiting for it to be consumed
 *------------------------------------------------------------------------
 */

int prod2(semid, indx1, indx2)
int semid, indx1, indx2;
{
	int	i;


	for (i=1; i<=20; i++) {
		waitsem(semid, indx1);
		(*n)++;
		sigsem(semid, indx2);
	}
}

/*------------------------------------------------------------------------
 *  cons2  --  print n 20 times, waiting for it to be produced
 *------------------------------------------------------------------------
 */

int cons2(semid, indx1, indx2)
int semid, indx1, indx2;
{
	int	i;



	for (i=1; i<=20; i++) {
		waitsem(semid, indx1);
		printf("n is %d\n", *n);
		sigsem(semid, indx2);
	}
}
