/* shmq2.c -  prod2, cons2 */

#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <signal.h>
#include <unistd.h>


int     *n;             /* external variables are shared by all processes */
int     childpid;

typedef struct string_rec
{
  int busy_flag;
  char data[80];

} STRING_REC, *STRING_REC_PTR;


STRING_REC_PTR string_create(key)
int key;
{
  int result;
   STRING_REC_PTR semrec;
  
  
  result = shmget( (key_t) key,  sizeof(STRING_REC), 0666|IPC_CREAT);
  semrec = (STRING_REC_PTR) shmat(result, 0, 0);
   
  (*semrec).busy_flag = 0;
  (*semrec).data[0] = 0;
  

  return semrec;

}

void read_string(char dest[], STRING_REC_PTR  sptr )
{
  while ((*sptr).busy_flag == 1 )
   ;

 (*sptr).busy_flag = 1;
 strcpy(dest,(*sptr).data);  
 (*sptr).busy_flag = 0;

}

void write_string(STRING_REC_PTR  sptr, char source[] )
{
  while ((*sptr).busy_flag == 1 )
   ;
 (*sptr).busy_flag = 1;
  strcpy((*sptr).data, source);  
 (*sptr).busy_flag = 0;

}




void main()
{
  int id; 
  STRING_REC_PTR sptr;
  char str[80];

  sptr = string_create(11);

  if ( ( id =  fork() ) != 0 )
  {  /* select parent process */
     puts("**************  parent process ***********\n");
     write_string(sptr,"Hello World");
     read_string(str, sptr);
     printf("string is %s\n", str);
     puts("\n**************  parent process ***********\n");
    
     sleep(6);
     puts("**************  parent process ***********\n");
     read_string(str, sptr);
     printf("string is %s\n", str);
     puts("\n**************  parent process ***********\n");
     exit(0);
  }


     sleep(5);
     puts("**************  child process ***********\n");
     read_string(str, sptr);
     printf("string is %s\n", str);
     write_string(sptr,"Goodbye World");
     read_string(str, sptr);
     printf("string is %s\n", str);
     puts("\n**************  child process ***********\n");


}
