#include <stdio.h>
#include <errno.h>
#include <fcntl.h>

#define MAXOTW 7
#define MAXPROB 3
#define DRZEMKA 5

typedef enum {FALSE,TRUE} BOOLEAN;

static char *nazwafifo(klucz)
long klucz;
{
static char fifo[20];

sprintf(fifo,"/tmp/fifo%ld",klucz);
return(fifo);
}

static int otworzfifo(klucz,flagi)
long klucz;
int flagi;
{
static struct{
long klucz;
int deskr;
int czas;
} kolejki[MAXOTW];

static int zegar;
int i, dostepny,stary,deskr,licznik;
char *nazwa;
extern int errno;

zegar++;
dostepny=-1;
for(i=0;i<MAXOTW;i++){
  if(kolejki[i].klucz==klucz){
     kolejki[i].czas=zegar;
     return(kolejki[i].deskr);
  }
  if(kolejki[i].klucz==0 && dostepny==-1)
    dostepny=i;
}

if(dostepny==-1){
   stary=-1;
   for(i=0;i<MAXOTW;i++)
       if(stary==-1 || kolejki[i].czas < stary){
          stary=kolejki[i].czas;
          dostepny=i;
       }
   if(close(kolejki[dostepny].deskr)==-1)
      return -1;
}

nazwa=nazwafifo(klucz);
if(stworzfifo(nazwa)==-1 && errno!=EEXIST)
   return -1;

for(licznik=1;licznik<=MAXPROB;licznik++){
    if((deskr=open(nazwa,flagi|O_NDELAY))!=-1)
        break;
    if(errno!=ENXIO)
       return -1;
    sleep(DRZEMKA);
}

if(deskr==-1){
   errno=ENXIO;
   return -1;
}

if(fcntl(deskr,F_SETFL,flagi)==-1)
   return -1;

kolejki[dostepny].klucz=klucz;
kolejki[dostepny].deskr=deskr;
kolejki[dostepny].czas=zegar;
return(deskr);
}

BOOLEAN przeslij(klucz,buf,lbajt)
long klucz;
char *buf;
int lbajt;
{
int deskr;

if((deskr=otworzfifo(klucz,O_WRONLY))==-1)
    return(FALSE);
return(write(deskr,buf,lbajt)!=-1);
}

BOOLEAN odbierz(klucz,buf,lbajt)
long klucz;
char *buf;
int lbajt;
{
int deskr,licznik;

if((deskr=otworzfifo(klucz,O_RDONLY))==-1)
    return(FALSE);
while((licznik=read(deskr,buf,lbajt))==0)
       sleep(DRZEMKA);
return(licznik!=-1);
}

void usunkol(klucz)
long klucz;
{
extern int errno;
if(unlink(nazwafifo(klucz))==-1 && errno !=ENOENT)
  syserr("unlink");
}

