/* sync1.c -  prod2, cons2 */

#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/shm.h>

typedef struct n
{
  int n;
  int flag1;
  int flag2;

} N, *NPTR;

volatile NPTR n;		



/*------------------------------------------------------------------------
 *  main  --  producer and consumer processes synchronized with semaphores
 *------------------------------------------------------------------------
 */
int  main()
{
	int	prod2(), cons2();
	int	semid, shmid;
        struct shmid_ds buff;


        shmid = shmget(IPC_PRIVATE, sizeof(N), 0666);  
        n = (NPTR)shmat(shmid,0,0);
        n->n = 0;
        n->flag1 = 0;
        n->flag2 = 1;


        if ( fork() )
          /* Parent process    */
            cons2();
        else /* Child process */
         prod2();

        shmdt((char *)n);
        shmctl(shmid, IPC_RMID, &buff);

   return 0;
}

/*------------------------------------------------------------------------
 *  prod2  --  increment n 20 times
 *------------------------------------------------------------------------
 */

int prod2()
{
	int	i;


	for (i=1; i<=20; i++) {
             while(n->flag1 == 0)
                ;
             (n->n)++;
             n->flag2 = 1;
             n->flag1 = 0;
	}
}

/*------------------------------------------------------------------------
 *  cons2  --  print n 20 times
 *------------------------------------------------------------------------
 */

int cons2()
{
	int	i;



	for (i=1; i<=20; i++) {
             while(n->flag2 == 0)
                   ;
             printf("n is %d\n", n->n);
             n->flag1 = 1;
             n->flag2 = 0;
	}
}
