/* cp.c - copy one file using unbuffered io */

#include <fcntl.h>
#include <sys\stat.h>
#include <io.h>
#include <stdio.h>
#include <stdlib.h>
#define BUFFSIZE 10


void main(int argc, char *argv[])
{
  int inpfd, outpfd;       /* File descriptors */
  char buff[BUFFSIZE];   /* Temporary storage buffer */
  int n;                 /* Number of characters */

  if (argc != 3)
    {
     printf("Usage: %s orgfilename copyfilename\n", argv[0]);
     exit(1);
    }

  if ( (inpfd = open(argv[1],O_RDONLY) ) == -1 )
   /* open input file, if cannot */
   {
    fprintf(stderr,"Cannot open file %s\n",argv[1]);
    exit(2);
   }

  if ( (outpfd = open(argv[2],O_CREAT) ) == -1 )
  /* open output file, if cannot */
   {
    fprintf(stderr,"Cannot open file %s\n",argv[2]);
    exit(3);
   }

  while ( (n = read(inpfd, buff, BUFFSIZE) ) > 0 ) /* Read until end */
    write(outpfd, buff, n);

  close(inpfd);
  close(outpfd);

} /* main */

