/* unix_ex5.c - xmain, prod2, cons2 */

#include <stdio.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <signal.h>


typedef struct sem_rec
{
 int count;
 int waiting_pid;
} SEM_REC, *SEM_REC_PTR;

int screate(int count)
{
  int shmid;
  SEM_REC_PTR sptr;

  if (count < 0)
    return -1;
  shmid = shmget(IPC_PRIVATE, sizeof(SEM_REC), 0600|IPC_CREAT);
  sptr = shmat(shmid, 0, 0);
  sptr->count = count;
  return shmid;
} /* screate */

void sdelete(int shmid)
{
  struct shmid_ds *buff;

  shmctl(shmid, IPC_RMID, &buff);
} /* sdelete */

void wait_sem(int shmid)
{
  SEM_REC_PTR sptr;

  sptr = shmat(shmid, 0, 0);
  if ( (--sptr->count) < 0 )
    {
      sptr->waiting_pid = getpid();
      kill(getpid(), SIGSTOP);
    } /* if */

} /* wait_sem */

void signal_sem(int shmid)
{
  SEM_REC_PTR sptr;

  sptr = shmat(shmid, 0, 0);
  if ( (sptr->count++) < 0 )
     kill(sptr->waiting_pid, SIGCONT);
} /* wait_sem */


int	*nptr;


/*------------------------------------------------------------------------
 *  main  --  producer and consumer processes synchronized with semaphores
 *------------------------------------------------------------------------
 */
main()
{
	int	prod2(), cons2();
	int	produced, consumed;
        int shmid;
        int status;
        struct shmid_ds *buff;

        shmid = shmget(IPC_PRIVATE, sizeof(SEM_REC), 0600|IPC_CREAT);
        nptr = shmat(shmid, 0, 0);
        *nptr = 0;

	consumed = screate(0);
	produced = screate(1);
        if (fork()==0)
          prod2(consumed,produced);
        else
          cons2(consumed,produced);
     wait(&status);
     sdelete(consumed);
     sdelete(produced);
     shmctl(shmid, IPC_RMID, &buff);

} /* main  */

/*------------------------------------------------------------------------
 *  prod2  --  increment n 20 times, waiting for it to be consumed
 *------------------------------------------------------------------------
 */
prod2(consumed,produced)
int consumed,produced;
{
	int	i;

	for (i=1; i<=20; i++) {
		wait_sem(consumed);
		(*nptr)++;
		signal_sem(produced);
	}  /* for */
} /* prod2 */

/*------------------------------------------------------------------------
 *  cons2  --  print n 20 times, waiting for it to be produced
 *------------------------------------------------------------------------
 */
cons2(consumed,produced)
int consumed,produced;
{
	int	i;

	for (i=1; i<=20; i++) {
		wait_sem(produced);
		printf("*nptr is %d\n",*nptr);
		signal_sem(consumed);
	} /* for */
} /* cons2 */
